/*
 * This file is generated by jOOQ.
 */
package de.ship.clip.db.tables;


import de.ship.clip.db.Config;
import de.ship.clip.db.Keys;
import de.ship.clip.db.tables.records.TProfileRecord;

import java.util.Arrays;
import java.util.List;
import java.util.function.Function;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Function3;
import org.jooq.Identity;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Records;
import org.jooq.Row3;
import org.jooq.Schema;
import org.jooq.SelectField;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TProfile extends TableImpl<TProfileRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>config.t_profile</code>
     */
    public static final TProfile T_PROFILE = new TProfile();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TProfileRecord> getRecordType() {
        return TProfileRecord.class;
    }

    /**
     * The column <code>config.t_profile.pk</code>.
     */
    public final TableField<TProfileRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>config.t_profile.keycloak_id</code>.
     */
    public final TableField<TProfileRecord, String> KEYCLOAK_ID = createField(DSL.name("keycloak_id"), SQLDataType.CLOB.nullable(false), this, "");

    /**
     * The column <code>config.t_profile.theme</code>.
     */
    public final TableField<TProfileRecord, String> THEME = createField(DSL.name("theme"), SQLDataType.CLOB.defaultValue(DSL.field(DSL.raw("'light'::text"), SQLDataType.CLOB)), this, "");

    private TProfile(Name alias, Table<TProfileRecord> aliased) {
        this(alias, aliased, null);
    }

    private TProfile(Name alias, Table<TProfileRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table());
    }

    /**
     * Create an aliased <code>config.t_profile</code> table reference
     */
    public TProfile(String alias) {
        this(DSL.name(alias), T_PROFILE);
    }

    /**
     * Create an aliased <code>config.t_profile</code> table reference
     */
    public TProfile(Name alias) {
        this(alias, T_PROFILE);
    }

    /**
     * Create a <code>config.t_profile</code> table reference
     */
    public TProfile() {
        this(DSL.name("t_profile"), null);
    }

    public <O extends Record> TProfile(Table<O> child, ForeignKey<O, TProfileRecord> key) {
        super(child, key, T_PROFILE);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : Config.CONFIG;
    }

    @Override
    public Identity<TProfileRecord, Integer> getIdentity() {
        return (Identity<TProfileRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TProfileRecord> getPrimaryKey() {
        return Keys.T_PROFILE_PKEY;
    }

    @Override
    public List<UniqueKey<TProfileRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.T_PROFILE_KEYCLOAK_ID_KEY);
    }

    @Override
    public TProfile as(String alias) {
        return new TProfile(DSL.name(alias), this);
    }

    @Override
    public TProfile as(Name alias) {
        return new TProfile(alias, this);
    }

    @Override
    public TProfile as(Table<?> alias) {
        return new TProfile(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TProfile rename(String name) {
        return new TProfile(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TProfile rename(Name name) {
        return new TProfile(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TProfile rename(Table<?> name) {
        return new TProfile(name.getQualifiedName(), null);
    }

    // -------------------------------------------------------------------------
    // Row3 type methods
    // -------------------------------------------------------------------------

    @Override
    public Row3<Integer, String, String> fieldsRow() {
        return (Row3) super.fieldsRow();
    }

    /**
     * Convenience mapping calling {@link SelectField#convertFrom(Function)}.
     */
    public <U> SelectField<U> mapping(Function3<? super Integer, ? super String, ? super String, ? extends U> from) {
        return convertFrom(Records.mapping(from));
    }

    /**
     * Convenience mapping calling {@link SelectField#convertFrom(Class,
     * Function)}.
     */
    public <U> SelectField<U> mapping(Class<U> toType, Function3<? super Integer, ? super String, ? super String, ? extends U> from) {
        return convertFrom(toType, Records.mapping(from));
    }
}
